%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function sym_tensor(T,n). 
% Input: tensor T with dimension R^{n,n,n,n},
% Output: matrix M with dimension R^{n^2,n^2}.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function M = TensorToMatrix(T,n)
m = zeros(n^2,n^2);
for k = 1:n
    for l = 1:n
        m(:,((k-1)*n+l)) = reshape(T(:,:,k,l)',n^2,1);
    end
end

M = m;
