%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This is to test a randomly generated Tensor PCA problem.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


clear all; clc;

%% dimenstion of the problem
n = 6; d = 4; 
%% parameters
iter = 2000; mu = 0.5; rho=10;

[p,m] = psort(d); % p is the set of all the permutations of (1,2,...,d) 

%% randomly generate a 4-th order tensor
F = randn(n,n,n,n);

F=sym_tensor(F,p,m) % make F super-symmetric
    
%% Call ADM to solve tensor PCA

X0 = zeros(n^2,n^2); X0(1,1) = 1; Y0 = zeros(n^2,n^2); Y0(n^2,n^2) = 1; % generate starting point

mF = TensorToMatrix(F,n); % transform F to be a matrix

% [X_ADM,v_ADM,iternum_ADM] = ADMPCA_SDP(mF,X0,Y0,mu,n,iter,p,m); % use ADM to solve tensor PCA with SDP relaxation

[X_ADM,v_ADM,iternum_ADM] = ADMPCA(mF,X0,Y0,mu,rho,n,iter,p,m) ; % use ADM to solve tensor PCA with nuclear norm penalty

[C,D]=eig(X_ADM);
index=find(abs(diag(D))>0.0001);
L=length(index);
if L==1
     fprintf('Global optimal solution has been identified. \n'); 
     X=C(:,index); % find the eigenvector with maximum eigenvalue
     Y=reshape(X,n,n);
     [y,x]=eig(Y);
     I=find(abs(diag(x))>0.0001);
     fprintf('\n');
     fprintf('The optimal solution is: \n');
     y(:,I)
end 


